//+---------------------------------------------------------------------+
//|                                                 TrendTriggerMod.mq5 |
//|                                          Copyright  2004, Shimodax |
//|                                     http://www.strategybuilder.com/ | 
//+---------------------------------------------------------------------+
//|     SmoothAlgorithms.mqh      |
//|   (): terminal_data_folder\MQL5\Include             |
//+---------------------------------------------------------------------+
#property copyright "Copyright  2004, Shimodax"
#property link      "http://www.strategybuilder.com/"
#property version   "1.00"
//---     
#property indicator_separate_window
//---        
#property indicator_buffers 2
//---    
#property indicator_plots   1
//+-----------------------------------+
//|       |
//+-----------------------------------+
//---     
#property indicator_type1   DRAW_COLOR_HISTOGRAM
//---      
#property indicator_color1  clrGray,clrMagenta,clrSpringGreen
//---   -  
#property indicator_style1  STYLE_SOLID
//---     2
#property indicator_width1  2
//---   
#property indicator_label1  "Trend Trigger Mod"
//+-----------------------------------+
//|             |
//+-----------------------------------+
enum Applied_price_      //  
  {
   PRICE_CLOSE_ = 1,     // Close
   PRICE_OPEN_,          // Open
   PRICE_HIGH_,          // High
   PRICE_LOW_,           // Low
   PRICE_MEDIAN_,        // Median Price (HL/2)
   PRICE_TYPICAL_,       // Typical Price (HLC/3)
   PRICE_WEIGHTED_,      // Weighted Close (HLCC/4)
   PRICE_SIMPL_,         // Simple Price (OC/2)
   PRICE_QUARTER_,       // Quarted Price (HLOC/4) 
   PRICE_TRENDFOLLOW0_,  // TrendFollow_1 Price 
   PRICE_TRENDFOLLOW1_,  // TrendFollow_2 Price 
   PRICE_DEMARK_         // Demark Price 
  };
//+-----------------------------------+
//|         |
//+-----------------------------------+
input uint Regress=15;                 //    
input uint TLength=5;                  //  JMA                    
input  int TPhase=-100;                //  JMA ,
input Applied_price_ IPC=PRICE_CLOSE_; //  
input int Shift=0;                     //      
input int UpTriggerLevel= +50;         //  
input int DnTriggerLevel= -50;         //  
//+-----------------------------------+
//---   ,   
//---      
double ExtLineBuffer[];
double ColorExtLineBuffer[];
//---        
int min_rates_r,min_rates_total;
//--- 
#include <SmoothAlgorithms.mqh> 
//---    CJJMA   JJMASeries_Cls.mqh
CJJMA JMA;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+ 
void OnInit()
  {
//---   
   min_rates_r=int(Regress+Regress+1);
   min_rates_total=min_rates_r+30;
//---    ExtLineBuffer   
   SetIndexBuffer(0,ExtLineBuffer,INDICATOR_DATA);
//---          
   ArraySetAsSeries(ExtLineBuffer,true);
//---     ,     
   SetIndexBuffer(1,ColorExtLineBuffer,INDICATOR_COLOR_INDEX);
//---          
   ArraySetAsSeries(ColorExtLineBuffer,true);
//---       Shift
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//---      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//---      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0.0);
//---      
   string shortname;
   StringConcatenate(shortname,"Trend Trigger Mod(",TLength," ,",TPhase,")");
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//---       
   JMA.JJMALengthCheck("TLength", TLength);
   JMA.JJMAPhaseCheck("TPhase", TPhase);
//---      3   
   IndicatorSetInteger(INDICATOR_LEVELS,3);
//---       
   IndicatorSetDouble(INDICATOR_LEVELVALUE,0,UpTriggerLevel);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,1,DnTriggerLevel);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,2,0);
//---             
   IndicatorSetInteger(INDICATOR_LEVELCOLOR,0,Blue);
   IndicatorSetInteger(INDICATOR_LEVELCOLOR,1,Blue);
   IndicatorSetInteger(INDICATOR_LEVELCOLOR,2,Brown);
//---       -  
   IndicatorSetInteger(INDICATOR_LEVELSTYLE,0,STYLE_DASHDOTDOT);
   IndicatorSetInteger(INDICATOR_LEVELSTYLE,1,STYLE_DASHDOTDOT);
   IndicatorSetInteger(INDICATOR_LEVELSTYLE,2,STYLE_DASHDOTDOT);
//---
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---       
   if(rates_total<min_rates_total)
      return(0);
//---    
   int limit,bar,maxbar;
   double HHR,LLR,HHO,LLO,BuyPower,SellPower,TTF;
//---         
   ArraySetAsSeries(open,true);
   ArraySetAsSeries(close,true);
   ArraySetAsSeries(high,true);
   ArraySetAsSeries(low,true);
//---
   maxbar=rates_total-min_rates_r-1;
//---    first    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      limit=rates_total-min_rates_r-1; //      
     }
   else
     {
      limit=rates_total-prev_calculated; //      
     }
//---    
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      HHR=high[ArrayMaximum(high,bar,Regress)];
      HHO=high[ArrayMaximum(high,bar+Regress,Regress)];
      LLR=low[ArrayMinimum(low,bar,Regress)];
      LLO=low[ArrayMinimum(low,bar+Regress,Regress)];
      //---
      BuyPower=HHR-LLO;
      SellPower=HHO-LLR;
      TTF=100*(BuyPower-SellPower)*2/(BuyPower+SellPower);
      //---    JJMASeries. 
      //---  Phase  Length      (Din = 0) 
      ExtLineBuffer[bar]=JMA.JJMASeries(maxbar,prev_calculated,rates_total,0,TPhase,TLength,TTF,bar,true);
      ColorExtLineBuffer[bar]=0;
      if(ExtLineBuffer[bar]>UpTriggerLevel) ColorExtLineBuffer[bar]=2;
      if(ExtLineBuffer[bar]<DnTriggerLevel) ColorExtLineBuffer[bar]=1;
     }
//---     
   return(rates_total);
  }
//+------------------------------------------------------------------+
